#ifndef TOY_LOCK_H
#define TOY_LOCK_H

/*** A toy lock implementation */

#include <stdatomic.h>

typedef atomic_int lock_t;

static inline void init(lock_t *l)
{
	atomic_init(l, 0);
}

static inline void lock(lock_t *l)
{
	int r = 0;
	while (!atomic_compare_exchange_strong_explicit(l, &r, 1,
							memory_order_seq_cst,
							memory_order_seq_cst))
		r = 0;
}

static inline void unlock(lock_t *l)
{
	atomic_store_explicit(l, 0, memory_order_seq_cst);
}

#endif /* TOY_LOCK_H */
