#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <stdbool.h>
#include <stdatomic.h>
#include <assert.h>

#include "lib/queue.c"

#ifndef MAX_THREADS
# define MAX_THREADS 32
#endif

#ifndef HP_THREAD_LIMIT
# define HP_THREAD_LIMIT 32
#endif

#ifndef NUM_ENQ
# define NUM_ENQ 2
#endif

#ifndef NUM_DEQ
# define NUM_DEQ 0
#endif

queue_t *queue;
queue_t myqueue;
int num_threads;

int __thread tid;

__VERIFIER_hp_t hps[MAX_THREADS + 1][HP_THREAD_LIMIT];
int __thread __hp_index;

void set_thread_num(int i)
{
	tid = i;
}

int get_thread_num()
{
	return tid;
}

__VERIFIER_hp_t *get_free_hp()
{
	int index = __hp_index++;
	assert(index < HP_THREAD_LIMIT);
	return &hps[tid][index];
}

void *thread_enq(void *param)
{
	int pid = (intptr_t ) param;

	set_thread_num(pid);
	enqueue(queue, 1);
	return NULL;
}

void *thread_deq(void *param)
{
	int pid = (intptr_t ) param;
	unsigned dequeued;

	set_thread_num(pid);

	__VERIFIER_assume(dequeue(queue, &dequeued));
	return NULL;
}

int main()
{
	pthread_t ts[NUM_ENQ+NUM_DEQ+1];

	queue = &myqueue;
	num_threads = NUM_ENQ + NUM_DEQ;

	init_queue(queue, num_threads);

	int i = 1;
	for (int j = 1; j <= NUM_ENQ; j++, i++) {
                if (j == 1)
                        pthread_create(&ts[i], NULL, thread_enq, (void *) (intptr_t) i);
                else
                        ts[i] = __VERIFIER_spawn_symmetric(thread_enq, (void *) (intptr_t) i, ts[i-1]);
        }
	for (int j = 1; j <= NUM_DEQ; j++, i++) {
                if (j == 1)
                        pthread_create(&ts[i], NULL, thread_deq, (void *) (intptr_t) i);
                else
                        ts[i] = __VERIFIER_spawn_symmetric(thread_deq, (void *) (intptr_t) i, ts[i-1]);
	}

	i = 1;
	for (int j = 1; j <= NUM_ENQ; j++, i++) {
                if (j == 1)
                        pthread_join(ts[i], NULL);
                else
                        __VERIFIER_join_symmetric(ts[i]);
	}
	for (int j = 1; j <= NUM_DEQ; j++, i++) {
                if (j == 1)
                        pthread_join(ts[i], NULL);
                else
                        __VERIFIER_join_symmetric(ts[j]);
	}
	return 0;
}
